import 'package:diplomaticquarterapp/core/model/my_trakers/blood_sugar/DiabtecPatientResult.dart';
import 'package:diplomaticquarterapp/core/model/my_trakers/chartData/WeekChartDate.dart';
import 'package:diplomaticquarterapp/core/viewModels/medical/blood_sugar_view_model.dart';
import 'package:diplomaticquarterapp/core/viewModels/project_view_model.dart';
import 'package:diplomaticquarterapp/pages/medical/my_trackers/widget/LineChartCurved.dart';
import 'package:diplomaticquarterapp/uitl/date_uitl.dart';
import 'package:diplomaticquarterapp/uitl/translations_delegate_base.dart';
import 'package:diplomaticquarterapp/widgets/charts/app_time_series_chart.dart';
import 'package:diplomaticquarterapp/widgets/data_display/text.dart';
import 'package:diplomaticquarterapp/widgets/others/app_scaffold_widget.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:charts_flutter/flutter.dart' as charts;
import 'package:hexcolor/hexcolor.dart';
import 'package:provider/provider.dart';

class BloodYearPage extends StatelessWidget {
  final List<DiabtecPatientResult> diabtecPatientResult;
  final List<TimeSeriesSales2> timeSeriesData;
  final BloodSugarViewMode bloodSugarViewMode;

  const BloodYearPage({Key key, this.diabtecPatientResult, this.timeSeriesData, this.bloodSugarViewMode}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    ProjectViewModel projectViewModel = Provider.of(context);
    return AppScaffold(
      // baseViewModel: bloodSugarViewMode,
      body: ListView(
              children: [
                Container(
                    margin: EdgeInsets.only(top: 12, left: 8, right: 8),
                    width: double.maxFinite,
                    color: Colors.white,
                    child: LineChartCurved(
                      title: '${TranslationBase.of(context).bloodSugar}',
                      timeSeries: timeSeriesData.isEmpty?[TimeSeriesSales2(DateTime.now(),0.0)]:timeSeriesData,
                      indexes: timeSeriesData.length ~/ 5.5 ?? 0,
                    )),
                SizedBox(
                  height: 12,
                ),
                Padding(
                  padding: const EdgeInsets.all(8.0),
                  child: Texts(TranslationBase.of(context).details),
                ),
                Container(
                  padding: EdgeInsets.all(10),
                  color: Colors.transparent,
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: <Widget>[
                      timeSeriesData.isEmpty
                          ? Container(
                        child: Center(
                          child: Texts(TranslationBase.of(context).noDataAvailable),
                        ),
                      )
                          :Table(
                        border: TableBorder.symmetric(
                          inside: BorderSide(width: 2.0, color: Colors.grey[300]),
                        ),
                        children: fullData(context, projectViewModel),
                      ),
                    ],
                  ),
                )
              ],
            ),
    );
  }

  List<TableRow> fullData(BuildContext context, ProjectViewModel projectViewModel) {
    List<TableRow> tableRow = [];
    tableRow.add(
      TableRow(
        children: [
          Container(
            child: Container(
              decoration: BoxDecoration(
                color: Theme.of(context).primaryColor,
                borderRadius: BorderRadius.only(
                  topLeft: projectViewModel.isArabic ? Radius.circular(0.0) : Radius.circular(10.0),
                  topRight: projectViewModel.isArabic ? Radius.circular(10.0) : Radius.circular(0.0),
                ),
              ),
              child: Center(
                child: Texts(
                  TranslationBase.of(context).date,
                  color: Colors.white,
                  fontSize: 15,
                ),
              ),
              height: 40,
            ),
          ),
          Container(
            child: Container(
                decoration: BoxDecoration(
                  color: Theme.of(context).primaryColor,
                ),
                child: Center(
                  child: Texts(
                    TranslationBase.of(context).time,
                    color: Colors.white,
                    fontSize: 15,
                  ),
                ),
                height: 40),
          ),
          Container(
            child: Container(
                decoration: BoxDecoration(
                  color: Theme.of(context).primaryColor,
                ),
                child: Center(
                  child: Texts(
                    TranslationBase.of(context).measured,
                    color: Colors.white,
                    fontSize: 15,
                  ),
                ),
                height: 40),
          ),
          Container(
            child: Container(
                decoration: BoxDecoration(
                  color: Theme.of(context).primaryColor,
                  borderRadius: BorderRadius.only(
                    topLeft: projectViewModel.isArabic ? Radius.circular(10.0) : Radius.circular(0.0),
                    topRight: projectViewModel.isArabic ? Radius.circular(0.0) : Radius.circular(10.0),
                  ),
                ),
                child: Center(
                  child: Texts(
                    TranslationBase.of(context).value,
                    color: Colors.white,
                    fontSize: 15,
                  ),
                ),
                height: 40),
          ),
        ],
      ),
    );
    diabtecPatientResult.forEach(
      (diabtec) {
        tableRow.add(
          TableRow(
            children: [
              Container(
                child: Container(
                  height: 70,
                  padding: EdgeInsets.all(10),
                  color: Colors.white,
                  child: Center(
                    child: Texts(
                      '${projectViewModel.isArabic ? DateUtil.getMonthDayYearDateFormattedAr(diabtec.dateChart) : DateUtil.getMonthDayYearDateFormatted(diabtec.dateChart)} ',
                      textAlign: TextAlign.center,
                      fontSize: 12,
                    ),
                  ),
                ),
              ),
              Container(
                child: Container(
                  height: 70,
                  padding: EdgeInsets.all(10),
                  color: Colors.white,
                  child: Center(
                    child: Texts(
                      '${diabtec.dateChart.hour}:${diabtec.dateChart.minute}',
                      textAlign: TextAlign.center,
                      fontSize: 12,
                    ),
                  ),
                ),
              ),
              Container(
                child: Container(
                  height: 70,
                  padding: EdgeInsets.all(10),
                  color: Colors.white,
                  child: Center(
                    child: Texts(
                      '${diabtec.measuredDesc}',
                      textAlign: TextAlign.center,
                      fontSize: 12,
                    ),
                  ),
                ),
              ),
              Container(
                child: Container(
                  height: 70,
                  padding: EdgeInsets.all(10),
                  color: Colors.white,
                  child: Center(
                    child: Texts(
                      '${diabtec.resultValue}',
                      textAlign: TextAlign.center,
                      fontSize: 12,
                    ),
                  ),
                ),
              ),
            ],
          ),
        );
      },
    );
    return tableRow;
  }
}
